//+------------------------------------------------------------------+
//|                                                          ATR.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue
//---- input parameters
extern int AtrPeriod=14;
//---- buffers
double Balance[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 1 additional buffer used for counting.
   IndicatorBuffers(1);
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Balance);
//---- name for DataWindow and indicator subwindow label
   short_name="Balance";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   SetIndexDrawBegin(0,AtrPeriod);
   IndicatorDigits(Digits-2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Average True Range                                               |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
//----
   if(Bars<=AtrPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=AtrPeriod;i++) Balance[Bars-i]=0.0;
//----
      Balance[0]=AccountBalance();
   i=0;
//
   while(i<500)
     {
//ͳ
//
      double profit=0;
//
      for(int j=HistoryTotal()-1;j>=0;j--)                 //ɽԶ
      {
       if(OrderSelect(j,SELECT_BY_POS,MODE_HISTORY)==false)     break;
//
       int shift=iBarShift(Symbol(),Period(),OrderCloseTime());
//
       if(shift>i) break;
       if(shift==i && OrderProfit()<0.76*Balance[i]) profit+=OrderProfit();
      }
//
      Balance[i+1]=Balance[i]-profit;
//
      if(j<=0) break;
      i++;
     }
//
   return(0);
  }
//+------------------------------------------------------------------+